#include <OSA.h>

#ifdef __OSAPICC__
#include <pic.h>
#endif

#ifdef __OSAPICC12__
#include <pic.h>
#endif

#ifdef __OSAPICC18__
#include <pic18.h>
#endif

#ifdef __OSAMCC18__
#include <p18f252.h>
#endif

#ifdef __OSACSS18__
#include <18F252.H>
#endif


unsigned char counter;

//------------------------------------------------------------------------------
void Task_T9 (void)
{
    for (;;)
    {
LABEL_START:
        OS_SetBSem(0);
        OS_SetBSem(1);
        OS_SetBSem(2);
        OS_Yield();

    }
}


//------------------------------------------------------------------------------
void Task_T0 (void)
{for (;;) { 
    OS_WaitBSem(0);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T1 (void)
{for (;;) { 
    OS_WaitBSem(1);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T2 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T3 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T4 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T5 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T6 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T7 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------
void Task_T8 (void)
{for (;;) { 
    OS_WaitBSem(2);
    counter++;
}}    

//------------------------------------------------------------------------------

void main (void)
{
    char cTestMode;
    
    OS_Init();
    
    cTestMode = 3;

    switch (cTestMode)
    {
    case 1:
        OS_CreateTask(2, Task_T0);
        OS_CreateTask(0, Task_T1);
        OS_CreateTask(2, Task_T2);
        OS_CreateTask(5, Task_T3);
        OS_CreateTask(3, Task_T4);
    #ifndef __OSAPICC12__
        OS_CreateTask(2, Task_T5);
        OS_CreateTask(6, Task_T6);
    #endif
        OS_CreateTask(1, Task_T7);
        OS_CreateTask(4, Task_T8);
        OS_CreateTask(7, Task_T9);
        break;

    case 2:
        OS_CreateTask(1, Task_T0);
        OS_CreateTask(1, Task_T1);
        OS_CreateTask(1, Task_T2);
        OS_CreateTask(1, Task_T3);
        OS_CreateTask(1, Task_T4);
    #ifndef __OSAPICC12__
        OS_CreateTask(1, Task_T5);
        OS_CreateTask(1, Task_T6);
    #endif
        OS_CreateTask(1, Task_T7);
        OS_CreateTask(1, Task_T8);
        OS_CreateTask(1, Task_T9);
        break;

    case 3:
        OS_CreateTask(0, Task_T0);
        OS_CreateTask(0, Task_T1);
        OS_CreateTask(0, Task_T2);
        OS_CreateTask(0, Task_T3);
        OS_CreateTask(0, Task_T4);
    #ifndef __OSAPICC12__
        OS_CreateTask(0, Task_T5);
        OS_CreateTask(0, Task_T6);
    #endif
        OS_CreateTask(0, Task_T7);
        OS_CreateTask(0, Task_T8);
        OS_CreateTask(0, Task_T9);
        break;
    }
        
    for (;;)
    {
        OS_CLRWDT();
        OS_Sched();
    }
}
